/* Copyright 2006, freshmowed software.  All rights reserved. */

Utilities = function() { }

Utilities.MILLISECS_PER_DAY = ( 24 * 60 * 60 * 1000);

Utilities.limit = function(aValue, minValue, maxValue)
{
    return aValue < minValue ? minValue : (aValue > maxValue ? maxValue : aValue );
}

Utilities.lowerLimit = function(aValue, minValue)
{
    return aValue < minValue ? minValue : aValue;
}

Utilities.upperLimit = function(aValue, maxValue)
{
    return aValue > maxValue ? maxValue : aValue;
}

Utilities.nextValue = function(from, to, slope) 
{
    return from + (to - from) * slope;
}

Utilities.beginningOfYearUTC = function()
{
  var currentDate = new Date();
  var currentYear = currentDate.getUTCFullYear();
  var beginningOfYear = new Date().setTime(Date.UTC(currentYear, 0, 1));
  //alert("beginningOfYear: " + beginningOfYear);
  return beginningOfYear;
}

Utilities.beginningOfMonthUTC = function()
{
  var currentDate = new Date();
  var currentYear = currentDate.getUTCFullYear();
  var currentMonth = currentDate.getMonth();
  var beginningOfMonth = new Date().setTime(Date.UTC(currentYear, currentMonth, 1));
  //alert("beginningOfYear: " + beginningOfYear);
  return beginningOfMonth;
}

Utilities.dayOfYear = function()
{
  var currentDate = new Date();
  var currentYear = currentDate.getUTCFullYear();
  var beginningOfYear = new Date().setTime(Date.UTC(currentYear, 0, 1));
  var daysSinceBeginOfYear = (currentDate.getTime() - beginningOfYear) / (24 * 60 * 60 * 1000);
  //alert("dayOfYear: " + daysSinceBeginOfYear);
  return daysSinceBeginOfYear;
}

var daysOfMonth = new Array( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

Utilities.isLeapYear = function(year) 
{
    if ((year/4)   != Math.floor(year/4))   return false;
    if ((year/100) != Math.floor(year/100)) return true;
    if ((year/400) != Math.floor(year/400)) return false;
    return true;
}

Utilities.y2k = function(number)    
{ 
  return (number < 1000) ? number + 1900 : number; 
}

Utilities.daysInMonth = function(monthIndex, aDate)
{
  var theDate = (aDate) ? aDate : new Date();
  var daysInMonth = daysOfMonth[monthIndex];

  var year = Utilities.y2k(theDate.getYear());
  if ( Utilities.isLeapYear(year) && monthIndex == 1) daysInMonth++;

  return daysInMonth;
}


Utilities.daysAgoUTC = function(someNumDaysAgo)
{
  var currentDate = new Date();
  var currentDateUTC = currentDate.getTime();
  //currentDateUTC = Utilities.stripTimeFromUTC(currentDateUTC);
  var daysAgoDate = new Date().setTime(currentDateUTC - (someNumDaysAgo * Utilities.MILLISECS_PER_DAY));
  /* 
  if ( someNumDaysAgo == 0 )
  {
      alert("daysAgoUTC: " + daysAgoDate + " currentDate: " + currentDate + " current DSE: " + 
      currentDateUTC / Utilities.MILLISECS_PER_DAY + " numDSE():" + Utilities.numDaysSinceEpoch(currentDateUTC));
  }
  */
  return daysAgoDate;
}

Utilities.UTCDateByAddingDays = function(aUTCDate, numDays)
{
  var newUTCDate = Utilities.stripTimeFromUTC(aUTCDate) + (numDays * Utilities.MILLISECS_PER_DAY);
  result = new Date().setTime(newUTCDate);
  //alert("UTCDateByAddingDays: " + aDate + " new: " + result)
  return result;
}

/*  Returns an integer number of days since epoch.  Time since midnight is truncated. 
 *  Argument is a UTC date (milliseconds since epoch), or null for current date.
 */
Utilities.numDaysSinceEpoch = function(aUTCDate)
{
  if ( aUTCDate == null ) aUTCDate = new Date().getTime();
  
  var x = new Date();
  var offset = x.getTimezoneOffset() * 60 * 1000;
  
  return Math.floor((aUTCDate - offset) / Utilities.MILLISECS_PER_DAY) ;
}

Utilities.stripTime = function(aDate)
{ 
    var aUTCDate = aDate.getTime();
    var newUTCDate = Utilities.stripTimeFromUTC(aUTCDate);
    return new Date().setTime(newUTCDate);
}

Utilities.stripTimeFromUTC = function(aUTCDate)
{
    if ( aUTCDate == null ) aUTCDate = new Date().getTime();
    
    var shifted = Math.floor(aUTCDate / Utilities.MILLISECS_PER_DAY);
    
    //alert( "stripTimeFromUTC: before: " +  shifted + " after: " + shifted * Utilities.MILLISECS_PER_DAY );
    
    return shifted * Utilities.MILLISECS_PER_DAY;
  //return new Date().setTime(aUTCDate.getUTCFullYear(), aUTCDate.getMonth(), aUTCDate.getDate()));
}

Utilities.isValidDateString = function(aDateString)
{
  var aDate = Date.parse(aDateString);
  //alert("isValidDateString: " + !isNaN(aDate));
  return !isNaN(aDate);
}

Utilities.UTCDateFromValidatedString = function(aDateString)
{
  var aDate = Date.parse(aDateString) + (12 * 60 * 60 * 1000);
  return aDate;
}

Utilities.dateFromDaysSinceEpoch = function(numDaysSinceEpoch)
{
  var shifted = numDaysSinceEpoch * Utilities.MILLISECS_PER_DAY;
  var aDate = new Date();
  return aDate.setTime(shifted);
}

Utilities.formattedDateString = function(aUTC, form)
{
    var aDate = new Date();
    if ( aUTC != null ) aDate.setTime(aUTC);
    
    if ( form == null || form == 0 )
    {
        var strippedYear = (aDate.getFullYear() + "").substr(2);
        return (aDate.getUTCMonth() + 1) + "/" + aDate.getDate() + "/" + strippedYear;
    }
    else if ( form == 1)
    {
      var strippedYear = (aDate.getFullYear() + "").substr(2);
      var dateString = (aDate.getUTCMonth() + 1) + "/" + aDate.getDate() + "/" + strippedYear;
      var hour   = aDate.getHours();
      var minute = aDate.getMinutes();
      var second = aDate.getSeconds();
      var ap = "am";
      if (hour   > 11) { ap = "pm";             }
      if (hour   > 12) { hour = hour - 12;      }
      if (hour   == 0) { hour = 12;             }
      if (hour   < 10) { hour   = "0" + hour;   }
      if (minute < 10) { minute = "0" + minute; }
      if (second < 10) { second = "0" + second; }
      var timeString = hour + ':' + minute + ':' + second + "" + ap;
      return dateString + " " + timeString;
      
    }
    
    alert("Utilities.formattedDateString: unknown format: " + form);
    return "";
}

Utilities.compareNumbers = function(a,b)
{
    return a - b;
}

/* if the number is all zeros after the decimal place, don't show them */
Utilities.toFixedStripped = function(aFloat, decimalPlaces)
{
    var floored = Math.floor(aFloat);
    
    if ( aFloat - floored < 0.00001)
        return floored;
    
    // get rid of any trailing zeros (like make 185.50 -> 185.5)
    var dup = aFloat;
    var decimalPos = 1;
    for ( decimalPos = 1; decimalPos < decimalPlaces; decimalPos++ )
    {
       dup *= (decimalPos * 10.0);
       if ( (dup - Math.floor(dup)) < 0.00001 ) break;
    }
    
    return aFloat.toFixed(Math.min(decimalPlaces, decimalPos));       
}
